signatureColored = '[|cff00FF7FA|cff00ff00G|cff00FF7FA|r]';
local name, addon = ...
local login = true;
function AutoGroupAccept_Init()
	--------------------------------------------------------------------------------------------------
	-- Register Events -------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
	-- AutoGroupAccept:SetScript("Onevent", agaEvent);
	AutoGroupAccept:RegisterEvent("PARTY_INVITE_REQUEST");
	AutoGroupAccept:RegisterEvent("ADDON_LOADED");
	AutoGroupAccept:RegisterEvent("PLAYER_LOGIN");
	--------------------------------------------------------------------------------------------------
	-- GUI -------------------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
	-- Settings and stuff ----------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
	-- Backgrounds -----------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
	-- Configuration --
	local AGAConfig = CreateFrame("Frame","AGAConfig",UIParent)
	AGAConfig:SetFrameStrata("DIALOG")
	AGAConfig:SetWidth(400)
	AGAConfig:SetHeight(270)
	AGAConfig:EnableMouse(true)
	AGAConfig:SetBackdrop({
	bgFile = "Interface/DialogFrame/UI-DialogBox-Background", 
	edgeFile = "Interface/DialogFrame/UI-DialogBox-Border", tile = true, tileSize = 32, edgeSize = 32, 
	insets = { left = 11, right = 12, top = 12, bottom = 11 }});
	AGAConfig:SetPoint("CENTER",0,-15)
	-- First-time --
	local AGAFirstTime = CreateFrame("Frame","AGAFirstTime",UIParent)
	AGAFirstTime:SetFrameStrata("DIALOG")
	AGAFirstTime:SetWidth(340)
	AGAFirstTime:SetHeight(240)
	AGAFirstTime:EnableMouse(true)
	AGAFirstTime:SetBackdrop({
	bgFile = "Interface/DialogFrame/UI-DialogBox-Background", 
	edgeFile = "Interface/DialogFrame/UI-DialogBox-Border", tile = true, tileSize = 32, edgeSize = 32, 
	insets = { left = 11, right = 12, top = 12, bottom = 11 }});
	AGAFirstTime:SetPoint("CENTER",0,0)

	-- About --
	local AGAAbout = CreateFrame("Frame","AGAAbout",UIParent)
	AGAAbout:SetFrameStrata("DIALOG")
	AGAAbout:SetWidth(340)
	AGAAbout:SetHeight(150)
	AGAAbout:EnableMouse(true)
	AGAAbout:SetBackdrop({
	bgFile = "Interface/DialogFrame/UI-DialogBox-Background", 
	edgeFile = "Interface/DialogFrame/UI-DialogBox-Border", tile = true, tileSize = 32, edgeSize = 32, 
	insets = { left = 11, right = 12, top = 12, bottom = 11 }});
	AGAAbout:SetPoint("CENTER",0,225)
	--------------------------------------------------------------------------------------------------
	-- Title & Text -----------------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
	-- Configuration --
	local AGATitle = AGAConfig:CreateTexture(nil, "ARTWORK")
	AGATitle:SetPoint("TOP",0,13);
	AGATitle:SetTexture("Interface/DialogFrame/UI-DialogBox-Header");
	AGATitle:SetWidth(390);
	AGATitle:SetHeight(64);
	local AGATitleText = AGAConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	AGATitleText:SetPoint("TOP",0,-1);
	AGATitleText:SetText("|cff00FF7FAuto|cff00ff00Group|cff00FF7FAccept|r Config");
	-- About --
	local AGAAboutTitle = AGAAbout:CreateTexture(nil, "ARTWORK")
	AGAAboutTitle:SetPoint("TOP",0,13);
	AGAAboutTitle:SetTexture("Interface/DialogFrame/UI-DialogBox-Header");
	AGAAboutTitle:SetWidth(380);
	AGAAboutTitle:SetHeight(64);
	local AGAAboutTitleText = AGAAbout:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	AGAAboutTitleText:SetPoint("TOP",0,-1);
	AGAAboutTitleText:SetText("|cff00FF7FAuto|cff00ff00Group|cff00FF7FAccept|r About");
	local AGAAboutTitleText1 = AGAAbout:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	AGAAboutTitleText1:SetPoint("TOPLEFT", 20, -50);
	AGAAboutTitleText1:SetWidth(300)
	AGAAboutTitleText1:SetText("Addon made by |cffB51D1DUtriax|r, Tested by |cffB51D1DGlavock|r.");
	local AGAAboutTitleText2 = AGAAbout:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	AGAAboutTitleText2:SetPoint("TOPLEFT", 20, -80);
	AGAAboutTitleText2:SetWidth(300)
	AGAVersion = GetAddOnMetadata("AutoGroupAccept", "Version") 
	AGAAboutTitleText2:SetText("Version: ".. tostring(AGAVersion));
	-- First-time --
	local AGAFirstTimeTitle = AGAFirstTime:CreateTexture(nil, "ARTWORK")
	AGAFirstTimeTitle:SetPoint("TOP",0,13);
	AGAFirstTimeTitle:SetTexture("Interface/DialogFrame/UI-DialogBox-Header");
	AGAFirstTimeTitle:SetWidth(375);
	AGAFirstTimeTitle:SetHeight(64);
	local AGAFirstTimeTitleText = AGAFirstTime:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	AGAFirstTimeTitleText:SetPoint("TOP",0,-1);
	AGAFirstTimeTitleText:SetText("|cff00FF7FAuto|cff00ff00Group|cff00FF7FAccept|r");
	local AGAFirstTimeTitleText1 = AGAFirstTime:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	AGAFirstTimeTitleText1:SetPoint("TOPLEFT", 20, -60);
	AGAFirstTimeTitleText1:SetWidth(300)
	AGAFirstTimeTitleText1:SetText("Hi there!");
	local AGAFirstTimeTitleText2 = AGAFirstTime:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	AGAFirstTimeTitleText2:SetPoint("TOPLEFT", 20, -90);
	AGAFirstTimeTitleText2:SetWidth(300)
	AGAFirstTimeTitleText2:SetText("So this is your first time using this addon eh? type |cff00FF7F/aga help|r for all the commands.");
	local AGAFirstTimeTitleText3 = AGAFirstTime:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	AGAFirstTimeTitleText3:SetPoint("TOPLEFT", 20, -130);
	AGAFirstTimeTitleText3:SetWidth(300)
	AGAFirstTimeTitleText3:SetText("Or you can use the configuration panel to set the toggleable filters.");
	--------------------------------------------------------------------------------------------------
	-- CheckBoxes + Text ----------------------------------------------------------------------------- 
	--------------------------------------------------------------------------------------------------
	-- IsActive --
	local AGAIsActiveBox = CreateFrame("CheckButton", "AGAIsActiveBox", AGAConfig, "ChatConfigCheckButtonTemplate");
	AGAIsActiveBox:SetPoint("TOPLEFT", 25, -50);
	AGAIsActiveBox.tooltip = "Enabling this will allow the addon to work its magic.";
	AGAIsActiveBox:SetScript("OnClick", function() if sIsActive == true then sIsActive = false; else sIsActive = true; end PlaySound("igMainMenuOptionCheckBoxOn", "SFX"); end);
	local AGAIsActiveText = AGAConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	AGAIsActiveText:SetPoint("TOPLEFT", 50, -55 );
	AGAIsActiveText:SetText("Enable addon");
	-- IsFriendBool --
	local AGAIsFriendBoolBox = CreateFrame("CheckButton", "AGAIsFriendBoolBox", AGAConfig, "ChatConfigCheckButtonTemplate");
	AGAIsFriendBoolBox:SetPoint("TOPLEFT", 25, -50-25);
	AGAIsFriendBoolBox.tooltip = "Enable this to automatically accept all of your character's friends their invite towards you.";
	AGAIsFriendBoolBox:SetScript("OnClick", function() if sIsFriendBool == true then sIsFriendBool = false; else sIsFriendBool = true; end PlaySound("igMainMenuOptionCheckBoxOn", "SFX"); end);
	local AGAIsFriendBoolText = AGAConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	AGAIsFriendBoolText:SetPoint("TOPLEFT", 50, -55-25 );
	AGAIsFriendBoolText:SetText("Enable friend filter");
	-- BNIsFriendBool --
	local AGAIsBNFriendBoolBox = CreateFrame("CheckButton", "AGAIsBNFriendBoolBox", AGAConfig, "ChatConfigCheckButtonTemplate");
	AGAIsBNFriendBoolBox:SetPoint("TOPLEFT", 25, -50-50);
	AGAIsBNFriendBoolBox.tooltip = "Enable this to automatically accept all of your Battle.bet friends their invite towards you.";
	AGAIsBNFriendBoolBox:SetScript("OnClick", function() if sBNIsFriendBool == true then sBNIsFriendBool = false; else sBNIsFriendBool = true; end PlaySound("igMainMenuOptionCheckBoxOn", "SFX"); end);
	local AGAIsBNFriendBoolText = AGAConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	AGAIsBNFriendBoolText:SetPoint("TOPLEFT", 50, -55-50 );
	AGAIsBNFriendBoolText:SetText("Enable Battle.net friend filter");
	-- IsGuildBool --
	local AGAIsGuildBoolBox = CreateFrame("CheckButton", "AGAIsGuildBoolBox", AGAConfig, "ChatConfigCheckButtonTemplate");
	AGAIsGuildBoolBox:SetPoint("TOPLEFT", 25, -50-75);
	AGAIsGuildBoolBox.tooltip = "Enable this to automatically accept all of your guild members their invite towards you.";
	AGAIsGuildBoolBox:SetScript("OnClick", function() if sIsGuildBool == true then sIsGuildBool = false; else sIsGuildBool = true; end PlaySound("igMainMenuOptionCheckBoxOn", "SFX"); end);
	local AGAIsGuildBoolText = AGAConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	AGAIsGuildBoolText:SetPoint("TOPLEFT", 50, -55-75 );
	AGAIsGuildBoolText:SetText("Enable guild member filter");	
	-- IsSilence --
	local AGAIsSilenceBox = CreateFrame("CheckButton", "AGAIsSilenceBox", AGAConfig, "ChatConfigCheckButtonTemplate");
	AGAIsSilenceBox:SetPoint("TOPLEFT", 25, -50-100);
	AGAIsSilenceBox.tooltip = "Enabling this causes no notifications to get printed into the chat box.";
	AGAIsSilenceBox:SetScript("OnClick", function() if sIsSilence == true then sIsSilence = false; else sIsSilence = true; end PlaySound("igMainMenuOptionCheckBoxOn", "SFX"); end);
	local AGAIsSilenceText = AGAConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	AGAIsSilenceText:SetPoint("TOPLEFT", 50, -55-100 );
	AGAIsSilenceText:SetText("Silence notifications");
	--------------------------------------------------------------------------------------------------
	-- Buttons ---------------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
	-- igCharacterInfoOpen 
    -- igCharacterInfoClose 
	-- Config FROM first-time --
	local AGAConfigFirstTime = CreateFrame("Button", "AGAConfigFirstTime", AGAFirstTime,"OptionsButtonTemplate");
	AGAConfigFirstTime:SetPoint("BOTTOMLEFT", 14, 16);
	AGAConfigFirstTime:SetText("Config");
	AGAConfigFirstTime:SetScript("OnClick", function()
		AGAFirstTime:Hide();
		AGAConfig:Show();
		PlaySound("igCharacterInfoOpen", "SFX");
		AGAIsActiveBox:SetChecked(sIsActive);
		AGAIsFriendBoolBox:SetChecked(sIsFriendBool);
		AGAIsBNFriendBoolBox:SetChecked(sBNIsFriendBool);
		AGAIsGuildBoolBox:SetChecked(sIsGuildBool);
		AGAIsSilenceBox:SetChecked(sIsSilence);
	end);
	-- About from first time --
	local AGAAboutFirstTime = CreateFrame("Button", "AGAAboutFirstTime", AGAFirstTime,"OptionsButtonTemplate");
	AGAAboutFirstTime:SetPoint("BOTTOM", 0, 16);
	AGAAboutFirstTime:SetText("About");
	AGAAboutFirstTime:SetScript("OnClick", function() AGAAbout:Show(); PlaySound("igCharacterInfoOpen", "SFX"); end);
	-- About from config --
	local AGAAboutConfig = CreateFrame("Button", "AGAAboutConfig", AGAConfig,"OptionsButtonTemplate");
	AGAAboutConfig:SetPoint("BOTTOM", 0, 16);
	AGAAboutConfig:SetText("About");
	AGAAboutConfig:SetScript("OnClick", function() AGAAbout:Show(); PlaySound("igCharacterInfoOpen", "SFX"); end);
	-- Purge --
	local AGAPurge = CreateFrame("Button", "AGAPurge", AGAConfig,"OptionsButtonTemplate");
	AGAPurge:SetPoint("BOTTOMLEFT", 14, 16);
	AGAPurge:SetText("Purge");
	AGAPurge:SetScript("OnClick", function() StaticPopup_Show("Purge_popup") end);
	StaticPopupDialogs["Purge_popup"] = {
		text = "Are you sure you want to empty your AutoGroupAccept character lists?",
		button1 = "Yes", button2 = "No",
		OnAccept = function() sTableAdded = {}; sTableBlocked = {}; end,
		timeout = 0, whileDead = true, hideOnEscape = true, preferredIndex = 3,}
	-- Reset --
	local AGAReset = CreateFrame("Button", "AGAReset", AGAConfig,"OptionsButtonTemplate");
	AGAReset:SetPoint("BOTTOMLEFT", 14, 40);
	AGAReset:SetText("Reset");
	AGAReset:SetScript("OnClick", function() StaticPopup_Show("Reset_popup") end);
	StaticPopupDialogs["Reset_popup"] = {
		text = "Are you sure you want to reset the AutoGroupAccept Addon?",
		button1 = "Yes", button2 = "No",
		OnAccept = function() 
			sTableAdded = {}; sTableBlocked = {}; sIsFriendBool = false; sBNIsFriendBool = false; sIsGuildBool = false; sIsActive = true; sIsSilence = false;
			AGAIsActiveBox:SetChecked(sIsActive);
			AGAIsFriendBoolBox:SetChecked(sIsFriendBool);
			AGAIsBNFriendBoolBox:SetChecked(sBNIsFriendBool);
			AGAIsGuildBoolBox:SetChecked(sIsGuildBool);
			AGAIsSilenceBox:SetChecked(sIsSilence);
			AGAConfig:Hide();
			AGAAbout:Hide();
			AGAFirstTime:Show();
			PlaySound("igCharacterInfoOpen", "SFX");
	  end,
		timeout = 0, whileDead = true, hideOnEscape = true, preferredIndex = 3,}
	-- Close config --
	local AGACloseConfig = CreateFrame("Button", "AGACloseConfig", AGAConfig,"OptionsButtonTemplate");
	AGACloseConfig:SetPoint("BOTTOMRIGHT", -14, 16);
	AGACloseConfig:SetText("Close");
	AGACloseConfig:SetScript("OnClick", function() AGAConfig:Hide(); PlaySound("igCharacterInfoClose", "SFX"); end);	
	-- Close about --
	local AGACloseAbout = CreateFrame("Button", "AGACloseAbout", AGAAbout,"OptionsButtonTemplate");
	AGACloseAbout:SetPoint("BOTTOMRIGHT", -14, 16);
	AGACloseAbout:SetText("Close");
	AGACloseAbout:SetScript("OnClick", function() AGAAbout:Hide(); PlaySound("igCharacterInfoClose", "SFX"); end);	

	-- Close first-time --
	local AGACloseFirstTime = CreateFrame("Button", "AGACloseFirstTime", AGAFirstTime,"OptionsButtonTemplate");
	AGACloseFirstTime:SetPoint("BOTTOMRIGHT", -14, 16);
	AGACloseFirstTime:SetText("Close");
	AGACloseFirstTime:SetScript("OnClick", function() AGAFirstTime:Hide(); PlaySound("igCharacterInfoClose", "SFX"); end);	
	-- Start hidden --
	AGAConfig:Hide()
	AGAAbout:Hide()
	AGAFirstTime:Hide()
	--------------------------------------------------------------------------------------------------
	-- Table value check -----------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
	function get_key_for_value( t, value )
		for k,v in pairs(t) do if v==value then return k end end
		return nil
	end
	--------------------------------------------------------------------------------------------------
	-- Commands --------------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
	SLASH_AGA1 = '/aga';
	function SlashCmdList.AGA(msg, editbox)
		local msgTable = {}
		for word in msg:gmatch("%S+") do table.insert(msgTable, word) end
		if msgTable[1] == 'config' then
			--------------------------------------------------------------------------------------------------
			-- SHOW and update all the boxes -----------------------------------------------------------------
			--------------------------------------------------------------------------------------------------
			AGAConfig:Show();
			PlaySound("igCharacterInfoOpen", "SFX");
			AGAIsActiveBox:SetChecked(sIsActive);
			AGAIsFriendBoolBox:SetChecked(sIsFriendBool);
			AGAIsBNFriendBoolBox:SetChecked(sBNIsFriendBool);
			AGAIsGuildBoolBox:SetChecked(sIsGuildBool);
			AGAIsSilenceBox:SetChecked(sIsSilence);
		elseif msgTable[1] == 'toggle' then
			-------------------------------------------------------------------------------------
			-- Toggle commands ------------------------------------------------------------------
			-------------------------------------------------------------------------------------
			if msgTable[2] == 'friend' or msgTable[2] == 'friends' then
			-- Friend ------------------------
				if sIsFriendBool == true then
					sIsFriendBool = false;
					AGAIsFriendBoolBox:SetChecked(sIsFriendBool);
					print(signatureColored.." Accept friend(s) off");
				else
					sIsFriendBool = true;
					AGAIsFriendBoolBox:SetChecked(sIsFriendBool);
					print(signatureColored.." Accept friend(s) on");
				end
			elseif msgTable[2] == 'bnfriend' or msgTable[2] == 'bnfriends' then
				-- Battlenet -----------------
				if sBNIsFriendBool == true then
					sBNIsFriendBool = false;
					AGAIsBNFriendBoolBox:SetChecked(sBNIsFriendBool);
					print(signatureColored.." Accept Battle.NET friend(s) off");
				else
					sBNIsFriendBool = true;
					AGAIsBNFriendBoolBox:SetChecked(sBNIsFriendBool);
					print(signatureColored.." Accept Battle.NET friend(s) on");
				end
			elseif msgTable[2] == 'guild' or msgTable[2] == 'guildies' then
				-- Guild --------------------
				if sIsGuildBool == true then
					sIsGuildBool = false;
					AGAIsGuildBoolBox:SetChecked(sIsGuildBool);
					print(signatureColored.." Accept guild member(s) off");
				else
					sIsGuildBool = true;
					AGAIsGuildBoolBox:SetChecked(sIsGuildBool);
					print(signatureColored.." Accept guild member(s) on");
				end
			elseif msgTable[2] == 'addon' or msgTable[2] == 'plugin' then
				-- Friend -------------------
				if sIsActive == true then
					sIsActive = false;
					AGAIsActiveBox:SetChecked(sIsActive);
					print(signatureColored.." |cffcc0000AutoGroupAccept not accepting invites.");
				else
					sIsActive = true;
					AGAIsActiveBox:SetChecked(sIsActive);
					print(signatureColored.." |cff00cc00AutoGroupAccept accepting invites.");
			end
			else
				print(signatureColored.." |cff00FF7F/aga |cff00ff00toggle|r friends |cff00E5EEor|r bnfriends |cff00E5EEor|r guildies");
			end
		elseif msgTable[1] == 'help' or msgTable[1] == 'h' or msgTable[1] == '?' then
			--------------------------------------------------------------------------------------------------
			-- Help commands ---------------------------------------------------------------------------------
			--------------------------------------------------------------------------------------------------	 
			print("|cff00FF7FAuto|cff00ff00Group|cff00FF7FAccept|r |cffBABABAcommands:");
			print("|cffBABABAGeneral commands:");
			print("|cff00FF7F/aga |rhelp");
			print("|cff00FF7F/aga |rshow |cff00E5EEor|r list");
			print("|cff00FF7F/aga |rconfig");
			print("|cff00FF7F/aga |rsilence |cff00E5EEor|r quiet |cff00E5EEor|r mute");
			print("|cff00FF7F/aga |rpurgeall -- Empties character lists.");
			print("|cffBABABAGroup toggle commands:");
			print("|cff00FF7F/aga |cff00ff00toggle|r friends |cff00E5EEor|r friend");
			print("|cff00FF7F/aga |cff00ff00toggle|r bnfriends |cff00E5EEor|r bnfriend");
			print("|cff00FF7F/aga |cff00ff00toggle|r guild |cff00E5EEor|r guildies");
			print("|cff00FF7F/aga |cff00ff00toggle|r addon |cff00E5EEor|r plugin");
			print("|cffBABABACharacter specific commands:");
			print("|cff00FF7F/aga |radd|r <character>");
			print("|cff00FF7F/aga |rremove|r <character>");
			print("|cff00FF7F/aga |rblock|r <character>");	
			print("|cff00FF7F/aga |runblock|r <character>");		
		elseif msgTable[1] == 'list' or msgTable[1] == 'show' then
			--------------------------------------------------------------------------------------------------
			-- Character Listing commands --------------------------------------------------------------------
			--------------------------------------------------------------------------------------------------
			local addedList = "";
			local blockedList = "";
			if sIsFriendBool then
				addedList = addedList .. ' [|cff00FF7FFriends|r] ';
			end
			if sBNIsFriendBool then
				addedList = addedList .. ' [|cff00FF7FBNET Friends|r] ';
			end
			if sIsGuildBool then
				addedList = addedList .. ' [|cff00FF7FGuildies|r] ';
			end
			for _, value,k in pairs(sTableAdded) do
				addedList = addedList .. value .. '  ';
			end
			if addedList == "" or addedList == nil then
				addedList = "|cffBABABANo added characters.";
			end
			print(signatureColored .. ' Allowed: '..addedList);
			for _, value,k in pairs(sTableBlocked) do
				blockedList = blockedList .. value .. '  ';
			end
			if blockedList == "" or blockedList == nil then
				blockedList = "|cffBABABANo blocked characters.";
			end
			print(signatureColored .. ' Blocked: '..blockedList);
		elseif msgTable[1] == 'add' then
			--------------------------------------------------------------------------------------------------
			-- ADD Command -----------------------------------------------------------------------------------
			--------------------------------------------------------------------------------------------------
			if msgTable[2] ~= nil and msgTable[2] ~= '' then
				local addingCharacter = true;
				for _, value in pairs(sTableAdded) do
					if string.upper(value) == string.upper(msgTable[2]) then
						addingCharacter = false;
					end
				end
				if addingCharacter then
					table.insert (sTableAdded, msgTable[2]);
					print(signatureColored .. ' ' .. msgTable[2] .. ' has been added.');
				else
					print(signatureColored .. ' ' .. msgTable[2] .. ' is already added.');
				end 
			else
				print(signatureColored .. ' Invalid command usage, |cff00FF7F/aga |cff00ff00add|r <character>');
			end
		elseif msgTable[1] == 'purgeall' then
		--------------------------------------------------------------------------------------------------
		-- Purge Command ---------------------------------------------------------------------------------
		--------------------------------------------------------------------------------------------------
		sTableAdded = {}
		sTableBlocked = {}
		print(signatureColored .. ' Allowed and Blocked list emptied. ');
		elseif msgTable[1] == 'remove' then
			--------------------------------------------------------------------------------------------------
			-- Remove Command ---------------------------------------------------------------------------------
			--------------------------------------------------------------------------------------------------
			if msgTable[2] ~= nil and msgTable[2] ~= '' then
				local removingCharacter = false;
				local n = 0;
				for _, value,k in pairs(sTableAdded) do
					if string.upper(value) == string.upper(msgTable[2]) and removingCharacter == false then
						removingCharacter = true;
						n = get_key_for_value( sTableAdded, value )
					end
				end
				if removingCharacter then
					sTableAdded[n] = nil;
					print(signatureColored .. ' ' .. msgTable[2] .. ' has been removed.');	 
				else
					print(signatureColored .. ' ' .. msgTable[2] .. ' is not added.');
				end
			else
				print(signatureColored .. ' Invalid command usage, |cff00FF7F/aga |cff00ff00remove|r <character>');
			end
		elseif msgTable[1] == 'block' then
			--------------------------------------------------------------------------------------------------
			-- Block Command ---------------------------------------------------------------------------------
			--------------------------------------------------------------------------------------------------
			if msgTable[2] ~= nil and msgTable[2] ~= '' then
				local addingCharacter = true;
				for _, value,k in pairs(sTableBlocked) do
					if string.upper(value) == string.upper(msgTable[2]) then
						addingCharacter = false;
					end
				end
				if addingCharacter then
					table.insert (sTableBlocked, msgTable[2]);
					print(signatureColored .. ' ' .. msgTable[2] .. ' has been blocked.');	 
				else
					print(signatureColored .. ' ' .. msgTable[2] .. ' is already blocked.');
				end
			else
				print(signatureColored .. ' Invalid command usage, |cff00FF7F/aga |cff00ff00block|r <character>');
			end
		elseif msgTable[1] == 'unblock' then
			--------------------------------------------------------------------------------------------------
			-- Purge Command ---------------------------------------------------------------------------------
			--------------------------------------------------------------------------------------------------
			if msgTable[2] ~= nil and msgTable[2] ~= '' then
				local removingCharacter = false;
				local n = 0
				for _, value in pairs(sTableBlocked) do
					if string.upper(value) == string.upper(msgTable[2]) and removingCharacter == false then
						removingCharacter = true;
						n = get_key_for_value( sTableBlocked, value )
					end
				end
				if removingCharacter then
					sTableBlocked[n] = nil;
					print(signatureColored .. ' ' .. msgTable[2] .. ' has been unblocked.');	 
				else
					print(signatureColored .. ' ' .. msgTable[2] .. ' is not blocked.');
				end
			else
				print(signatureColored .. ' Invalid command usage, |cff00FF7F/aga |cff00ff00unblock|r <character>');
			end
		elseif msgTable[1] == 'about' then
			-- About Command --
			AGAAbout:Show()
			PlaySound("igCharacterInfoOpen", "SFX");
		elseif msgTable[1] == 'silence' or msgTable[1] == 'quiet' or msgTable[1] == 'mute' then
			if sIsSilence == true then
				sIsSilence = false;
				AGAIsSilenceBox:SetChecked(sIsSilence);
				print(signatureColored.." Silence deactivated.");
			else
				sIsSilence = true;
				AGAIsSilenceBox:SetChecked(sIsSilence);
				print(signatureColored.." Silence activated.");
			end
			else
				print(signatureColored.." That is not an usable command, use |cff00FF7F/aga |cff00ff00help|r for more commands.");
			end
		end	

		if sIsFriendBool == nil then
			sIsFriendBool = false;
		end
		if sBNIsFriendBool == nil then
			sBNIsFriendBool = false;
		end
		if sIsGuildBool == nil then
			sIsGuildBool = false;
		end
		if sIsActive == nil then
			sIsActive = true;
		end
		if sIsSilence == nil then
			sIsSilence = false;
		end
		if sTableAdded == nil then
			sTableAdded = {}
		end
		if sTableBlocked == nil then
			sTableBlocked = {}
		end
		if sFirstTime == nil then
			sFirstTime = true;
		end
		
		
end

--------------------------------------------------------------------------------------------------
-- Accepting Code --------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------
function AutoGroupAccept_Event(self, event, sender, arg1, ...)
	--------------------------------------------------------------------------------------------------
	-- First time Setup ------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
	if(login and ((event == "ADDON_LOADED" and name == arg1) or (event == "PLAYER_LOGIN"))) then
	login = nil;
		if sFirstTime == true then
			AGAFirstTime:Show()
			PlaySound("igCharacterInfoOpen", "SFX");
			sFirstTime = false;
		end
	end
	--------------------------------------------------------------------------------------------------
	-- Accepting invites from friends ----------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
	if (event == "PARTY_INVITE_REQUEST") then
		local playerNumber = GetNumGroupMembers()
		if sIsActive == true and playerNumber == 0 then
			local isAllowed = false
			-- Get all character names -----------------------------------------------------------------------
			local onlineFriends = GetNumFriends() -- Get all the friends that are on.
			local numBNetOnline = BNGetNumFriends() -- Get the BN Friends that are on
			local numGuildMembers, numOnline, numOnlineAndMobile = GetNumGuildMembers() -- get Guildies
			local checkTableCharacters = {} -- Characters to check later on.
			if sIsFriendBool == true then
				for i=1, onlineFriends do
					local name, level, class, area, connected, status, note, RAF = GetFriendInfo(i);
					if connected == true then
						table.insert(checkTableCharacters, name);
					end
				end
			end
			if sBNIsFriendBool == true then
				for i=1, numBNetOnline do
					local presenceID, presenceName, battleTag, isBattleTagPresence, toonName, toonID, client, isOnline, lastOnline, isAFK, isDND, messageText, noteText, isRIDFriend, broadcastTime, canSoR = BNGetFriendInfo(i)
					if isOnline == true then
						table.insert(checkTableCharacters, toonName);
					end
				end
			end
			if sIsGuildBool == true then
				for i=1, numOnline do
					local fullName, rank, rankIndex, level, class, zone, note, officernote, online, status, classFileName, achievementPoints, achievementRank, isMobile, canSoR, reputation = GetGuildRosterInfo(i)
					if online == true then
						nameChar, realmName = fullName:match("([^,]+)-([^,]+)")
						table.insert(checkTableCharacters, nameChar);
					end
				end
			end
			--------------------------------------------------------------------------------------------------
			-- Purge Command ---------------------------------------------------------------------------------
			--------------------------------------------------------------------------------------------------
			if sTableAdded ~= nil then
				for _, value in pairs(sTableAdded) do
					if string.upper(value) == string.upper(sender) then
						isAllowed = true;
					end	
				end		
			end			
			-- Check if sender is in the table -- 
			for _, value in pairs(checkTableCharacters) do
				if value == sender and isAllowed == false then
					isAllowed = true;
				end
			end
			-- Check if User is blocked -- sTableBlocked
			for _, value in pairs(sTableBlocked) do
				if value == sender then
					isAllowed = false;
					if sIsSilence == false then
						print(signatureColored.." blocked character |cff00FF7F".. tostring(sender) .."|r tried to invite you.");
					end
				end
			end
			-- Check if everything checks out --
			if isAllowed then
				AcceptGroup();
				if sIsSilence == false then
					print(signatureColored.." You have accepted the invite from |cff00FF7F".. tostring(sender) .."|r.");
				end
				for i=1, STATICPOPUP_NUMDIALOGS do
					local dlg = _G["StaticPopup"..i]
					if dlg.which == "PARTY_INVITE" then
						dlg.inviteAccepted = 1
					break
				end
				end
				StaticPopup_Hide("PARTY_INVITE");
			end
		end
	end
end